const app = getApp()
import WxValidate from '../../utils/wxValidate'
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '组项信息', leftArrow: true, useBar: false },
        id: '',
        form: {},
        // 赛事信息
        matchList: [],
        // 组别
        groupingList: [],
        //组内项目
        projectList: [],
        // 组内人员
        personList: []
    },
    initValidate() {
        const rules = { match_id: { required: true }, grouping_id: { required: true }, project_id: { required: true }, name: { required: true }, rise: { required: true }, remark: { required: false } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { match_id: { required: '请选择赛事名称', }, grouping_id: { required: '请选择赛事组别', }, project_id: { required: '请选择组内项目', }, name: { required: '请输入组名' }, rise: { required: '请输入前x名晋级' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    back(e) { wx.navigateBack({ delta: 1 }) },
    // 选择赛事
    matchChange: function (e) {
        const that = this;
        let data = that.data.matchList[e.detail.value];
        if (data) {
            that.setData({ 'form.match_id': data._id });
            that.setData({ 'form.match_name': data.name });
            if (data.grouping && data.grouping.length > 0) {
                that.setData({ groupingList: data.grouping })
            }
        }
    },
    // 选择赛事组别
    grpupChange: async function (e) {
        const that = this;
        let data = that.data.groupingList[e.detail.value];
        if (data) {
            that.setData({ 'form.grouping_id': data._id });
            that.setData({ 'form.grouping_name': data.name });
            if (data.project && data.project.length > 0) {
                let projectList = [];
                for (const val of data.project) {
                    const arr = await app.$get(`/newCourt/api/matchProject/${val}`)
                    if (arr.errcode == '') projectList.push(arr.data);
                    that.setData({ projectList: projectList })
                }
            }
        }
    },
    // 选择组内项目
    projectChange: function (e) {
        const that = this;
        let data = that.data.projectList[e.detail.value];
        if (data) {
            that.setData({ 'form.project_id': data._id });
            that.setData({ 'form.project_name': data.name });
            that.setData({ 'form.type': data.type });
            // 查询组内人员
            that.searchPerson();
        }
    },
    // 查询组内人员
    searchPerson: async function (e) {
        const that = this;
        const form = that.data.form;
        let info = { match_id: form.match_id, grouping_id: form.grouping_id, project_id: form.project_id }
        const arr = await app.$get(`/newCourt/api/raceTeam/getRangePerson`, { ...info });
        if (arr.errcode == '0') { that.setData({ personList: arr.data }) }
        else { wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 }) }
    },
    // 选择组内人员
    personChange: function (e) {
        const that = this;
        const list = that.data.personList;
        const type = that.data.form.type;
        let person = [];
        if (type == '单打') {
            for (const val of e.detail.value) { let data = list.find((i) => i.openid == val); if (data) person.push({ ...data, checked: true }) }
        } else if (type == '双打') {
            for (const val of e.detail.value) { let data = list.find((i) => i.team_id == val); if (data) person.push({ ...data, checked: true }) }
        }
        that.setData({ 'form.person': person })
    },
    // 提交保存
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const person = that.data.form.person;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            if (person && person.length > 0) {
                params.person = person;
                let arr;
                if (that.data.id) { arr = await app.$post(`/newCourt/api/raceTeam/${that.data.id}`, params); }
                else { arr = await app.$post(`/newCourt/api/raceTeam`, params); }
                if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
                else wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
            } else {
                wx.showToast({ title: `请选择组内人员`, icon: 'error', duration: 2000 })
            }

        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        console.log(options);
        const that = this;
        //验证规则函数
        that.initValidate();
        that.setData({ id: options.id || '62eb1358d1c7ad6a16b963fb' });//62eb1138d1c7ad6a16b9600a   62eb1358d1c7ad6a16b963fb

        that.watchLogin()
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const match = await app.$get(`/newCourt/api/match`, { status: '0' });//2
                if (match.errcode == '0') { that.setData({ matchList: match.data }); };
                if (that.data.id) {
                    const arr = await app.$get(`/newCourt/api/raceTeam/${that.data.id}`);
                    if (arr.errcode == '0') {
                        // 比赛信息
                        let matchInfo = match.data.find((i) => i._id == arr.data.match_id);
                        if (matchInfo) {
                            arr.data.match_name = matchInfo.name;
                            // 赛事组别
                            let groupingInfo = matchInfo.grouping.find((i) => i._id == arr.data.grouping_id);
                            if (groupingInfo) { arr.data.grouping_name = groupingInfo.name; }
                            //  组内项目
                            let project = await app.$get(`/newCourt/api/matchProject/${arr.data.project_id}`)
                            if (project.errcode == '0') { arr.data.project_name = project.data.name; arr.data.type = project.data.type }
                        };
                        // 查询组内人员
                        let info = { match_id: arr.data.match_id, grouping_id: arr.data.grouping_id, project_id: arr.data.project_id }
                        const person = await app.$get(`/newCourt/api/raceTeam/getRangePerson`, { ...info });
                        let personList = []
                        if (person.errcode == '0') { personList = person.data }
                        for (const val of arr.data.person) { val.checked = true };
                        personList.unshift(...arr.data.person);
                        that.setData({ personList: personList })
                        that.setData({ form: arr.data })
                    }
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {


    },


    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})